package {

    import mx.controls.*;
    import mx.core.*;
    import mx.containers.*;    
    import flash.events.*;
    import flash.utils.*;
	  import gameObjects.MapRoom;
	  import gameObjects.ScoreEvent;
	  import gameObjects.MapTile;
    
    public class Tilegame {
        
        private static var mapRoom:MapRoom;
        private static var button:Button;
        private static var scoreValue:Text;
        private static var scoreLabel:Label;
        private static var header:Canvas;
        private static var score:int = 0;

        // Program entry point
        public static function main ():void {
          // Create a canvas
          header = new Canvas()
          
          // Create a button
          button = new Button();
          button.label = "Start";
          button.addEventListener(MouseEvent.CLICK, clickListener);

          var instructions:Label;
          instructions = new Label();
          instructions.text = "Click on all Count Words (words that have a plural form). "
          instructions.x = 100;
          

          var scorelabel:Label;
          scoreLabel = new Label();
          scoreLabel.text = "Score:"
          scoreLabel.x = 0;
          
          scoreValue = new Text();
          scoreValue.text = String(0);
          scoreValue.x = 50
        
          mapRoom = new MapRoom();

          // Add visual assets to the screen. Application.application is a 
          // reference to the top-level Flex application, a general container 
          // for controls and visual assets. 
          var mxmlApp:Application = Application(Application.application);
          mxmlApp.addEventListener(ScoreEvent.UPDATE, pickClicked);			
          
          header.addChild(scoreLabel);
          header.addChild(scoreValue);
          header.addChild(instructions);
          mxmlApp.addChild(header);

          mapRoom.startGame()
          header.width = 8*70

        }
        
        private static function clickListener (e:MouseEvent):void {
            mapRoom.startGame()
        }
        

        private static function pickClicked(e:ScoreEvent):void {
          if (e.tile.answer == "y") {
            score += 10;
            e.tile.removePick();
          } else if (e.tile.answer == "n") {
            score -= 10;
            e.tile.removePick();
          }
          if (score == 40) { mx.controls.Alert.show("You got them all.\nWell Done!")}
          scoreValue.text = String(score)
          /*
        			trace("Clicked:"+ Ball(e.target));
        			for (var i:int = balls.length-1; i >= 0; i ) {				
        				if (balls[i] == e.target) {
        					removeChild(balls[i]);	
        					balls.splice(i,1);
        					score+=e.score;
        					ScoreText.text = score.toString(); ;
        				}

        			}
            */
        }        
        
    }
}

